{-# LANGUAGE CPP #-}
{-# LANGUAGE NoRebindableSyntax #-}
#if __GLASGOW_HASKELL__ >= 810
{-# OPTIONS_GHC -Wno-prepositive-qualified-module #-}
#endif
{-# OPTIONS_GHC -fno-warn-missing-import-lists #-}
{-# OPTIONS_GHC -w #-}
module Paths_haddock_api (
    version,
    getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir,
    getDataFileName, getSysconfDir
  ) where


import qualified Control.Exception as Exception
import qualified Data.List as List
import Data.Version (Version(..))
import System.Environment (getEnv)
import Prelude


#if defined(VERSION_base)

#if MIN_VERSION_base(4,0,0)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#else
catchIO :: IO a -> (Exception.Exception -> IO a) -> IO a
#endif

#else
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
#endif
catchIO = Exception.catch

version :: Version
version = Version [2,30,0] []

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir `joinFileName` name)

getBinDir, getLibDir, getDynLibDir, getDataDir, getLibexecDir, getSysconfDir :: IO FilePath




bindir, libdir, dynlibdir, datadir, libexecdir, sysconfdir :: FilePath
bindir     = "${pkgroot}/../bin"
libdir     = "${pkgroot}/../lib/x86_64-linux-ghc-9.12.2-5f36/haddock-api-2.30.0-5654"
dynlibdir  = "${pkgroot}/../lib/x86_64-linux-ghc-9.12.2-5f36"
datadir    = "${pkgroot}/../share/x86_64-linux-ghc-9.12.2-5f36/haddock-api-2.30.0"
libexecdir = "${pkgroot}/../libexec/x86_64-linux-ghc-9.12.2-5f36/haddock-api-2.30.0"
sysconfdir = "${pkgroot}/../etc"

getBinDir     = catchIO (getEnv "haddock_api_bindir")     (\_ -> return bindir)
getLibDir     = catchIO (getEnv "haddock_api_libdir")     (\_ -> return libdir)
getDynLibDir  = catchIO (getEnv "haddock_api_dynlibdir")  (\_ -> return dynlibdir)
getDataDir    = catchIO (getEnv "haddock_api_datadir")    (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "haddock_api_libexecdir") (\_ -> return libexecdir)
getSysconfDir = catchIO (getEnv "haddock_api_sysconfdir") (\_ -> return sysconfdir)



joinFileName :: String -> String -> FilePath
joinFileName ""  fname = fname
joinFileName "." fname = fname
joinFileName dir ""    = dir
joinFileName dir fname
  | isPathSeparator (List.last dir) = dir ++ fname
  | otherwise                       = dir ++ pathSeparator : fname

pathSeparator :: Char
pathSeparator = '/'

isPathSeparator :: Char -> Bool
isPathSeparator c = c == '/'
